PipeWire: impl Struct Reference

PipeWire 0.3.34

Data Fields
impl Struct Reference

## Data Fields
struct pw_control | this
struct pw_memblock * | mem
struct pw_impl_device | this
struct spa_list | param_list
struct spa_list | pending_list
unsigned int | cache_params:1
struct pw_impl_metadata | this
struct metadata | def
struct pw_context * | context
struct pw_impl_metadata * | metadata
struct spa_hook | metadata_listener
struct pw_properties * | properties
struct spa_hook | context_listener
struct spa_hook | module_listener
struct pw_impl_module * | module
struct pw_work_queue * | work
uint32_t | id
struct pw_core * | core
struct spa_hook | core_proxy_listener
struct spa_hook | core_listener
struct spa_audio_info_raw | info
struct pw_stream * | capture
struct spa_hook | capture_listener
struct pw_properties * | source_props
struct pw_stream * | source
struct spa_hook | source_listener
void * | rec_buffer [SPA_AUDIO_MAX_CHANNELS]
uint32_t | rec_ringsize
struct spa_ringbuffer | rec_ring
struct spa_io_rate_match * | rec_rate_match
struct pw_stream * | playback
struct spa_hook | playback_listener
struct pw_properties * | sink_props
struct pw_stream * | sink
struct spa_hook | sink_listener
void * | play_buffer [SPA_AUDIO_MAX_CHANNELS]
uint32_t | play_ringsize
struct spa_ringbuffer | play_ring
struct spa_io_rate_match * | play_rate_match
void * | out_buffer [SPA_AUDIO_MAX_CHANNELS]
uint32_t | out_ringsize
struct spa_ringbuffer | out_ring
const struct echo_cancel_info * | aec_info
void * | aec
uint32_t | aec_blocksize
unsigned int | capture_ready:1
unsigned int | sink_ready:1
unsigned int | do_disconnect:1
unsigned int | unloading:1
struct pw_properties * | props
struct pw_properties * | stream_props
struct pw_stream * | stream
struct spa_hook | stream_listener
uint32_t | frame_size
struct spa_io_rate_match * | rate_match
struct spa_list | plugin_list
struct pw_properties * | capture_props
struct spa_audio_info_raw | capture_info
struct pw_properties * | playback_props
struct spa_audio_info_raw | playback_info
uint32_t | rate
struct graph | graph
struct spa_dbus_connection * | conn
DBusConnection * | bus
DBusPendingCall * | portal_pid_pending
pid_t | portal_pid
struct pw_global * | global
int64_t | count
uint32_t | busy
uint32_t | empty
struct spa_source * | flush_timeout
unsigned int | flushing:1
unsigned int | listening:1
struct spa_ringbuffer | buffer
uint8_t | tmp [TMP_BUFFER]
uint8_t | data [MAX_BUFFER]
uint8_t | flush [MAX_BUFFER+sizeof(struct spa_pod_struct)]
struct pw_protocol_pulse * | pulse
struct pw_loop * | loop
struct spa_list | server_list
struct pw_work_queue * | work_queue
bool | capture
bool | playback
uint32_t | mode
struct spa_ringbuffer | ring
void * | buffer
uint8_t | empty [8192]
pa_threaded_mainloop * | pa_mainloop
pa_context * | pa_context
pa_stream * | pa_stream
struct spa_thread_utils | thread_utils
int | rt_prio
rlim_t | rt_time_soft
rlim_t | rt_time_hard
struct pw_rtkit_bus * | system_bus
pthread_mutex_t | lock
pthread_cond_t | cond
struct spa_list | threads_list
int | nice_level
AvahiPoll * | avahi_poll
AvahiClient * | client
AvahiServiceBrowser * | sink_browser
AvahiServiceBrowser * | source_browser
struct spa_list | tunnel_list
struct sm_media_session * | session
struct spa_hook | listener
struct spa_list | client_list
struct pw_proxy * | proxy
struct spa_source * | notify
struct spa_hook | session_listener
struct pw_properties * | conf
struct spa_handle * | handle
struct spa_device * | monitor
struct spa_list | device_list
struct spa_source * | jack_timeout
struct pw_proxy * | jack_device
unsigned int | reserve:1
bool | have_info
bool | seat_active
struct spa_hook | meta_listener
unsigned int | record_count
unsigned int | communication_count
struct spa_source * | restore_timeout
char * | default_sink
bool | switched
struct spa_source * | idle_timeout
struct timespec | now
struct pw_properties * | to_restore
struct sm_media_session | this
struct pw_properties * | modules
struct pw_main_loop * | loop
struct spa_dbus * | dbus
struct spa_hook | dbus_connection_listener
struct pw_core * | monitor_core
struct spa_hook | monitor_listener
int | monitor_seq
struct pw_core * | policy_core
struct spa_hook | policy_listener
struct spa_hook | proxy_policy_listener
struct pw_registry * | registry
struct spa_hook | registry_listener
struct pw_registry * | monitor_registry
struct spa_hook | monitor_registry_listener
struct pw_map | globals
struct spa_list | object_list
| all sm_objects More...
struct spa_list | registry_event_list
| pending registry events More...
struct spa_hook_list | hooks
struct spa_list | endpoint_link_list
struct pw_map | endpoint_links
| list of struct endpoint_link More...
struct spa_list | link_list
| map of endpoint_link More...
struct spa_list | sync_list
| list of struct link More...
int | rescan_seq
| list of struct sync More...
int | last_seq
unsigned int | scanning:1
unsigned int | rescan_pending:1
unsigned int | seat_active:1
struct spa_hook | proxy_client_session_listener
struct spa_hook | client_session_listener
struct pw_metadata * | metadata
unsigned int | sync:1
struct spa_list | endpoint_list
int | seq
uint32_t | sample_rate
struct spa_list | node_list
unsigned int | node_list_changed:1
unsigned int | linking_node_removed:1
struct default_node | defaults [4]
bool | streams_follow_default
sd_login_monitor * | monitor
struct spa_source | source

## Field Documentation

## ◆ aec

void* impl::aec

## ◆ aec_blocksize

uint32_t impl::aec_blocksize

## ◆ aec_info

const struct echo_cancel_info* impl::aec_info

## ◆ avahi_poll

AvahiPoll* impl::avahi_poll

## ◆ buffer [1/2]

struct spa_ringbuffer impl::buffer

Referenced by pipewire__module_init().

## ◆ buffer [2/2]

void* impl::buffer

## ◆ bus

DBusConnection * impl::bus

## ◆ busy

uint32_t impl::busy

## ◆ cache_params

unsigned int impl::cache_params

Referenced by pw_context_create_device(), and pw_context_create_port().

## ◆ capture [1/2]

struct pw_stream * impl::capture

## ◆ capture [2/2]

bool impl::capture

## ◆ capture_info

struct spa_audio_info_raw impl::capture_info

## ◆ capture_listener

struct spa_hook impl::capture_listener

## ◆ capture_props

struct pw_properties * impl::capture_props

Referenced by pipewire__module_init().

## ◆ capture_ready

unsigned int impl::capture_ready

## ◆ client

AvahiClient* impl::client

## ◆ client_list

struct spa_list impl::client_list

Referenced by sm_access_flatpak_start(), and sm_access_portal_start().

## ◆ client_session_listener

struct spa_hook impl::client_session_listener

## ◆ communication_count

unsigned int impl::communication_count

## ◆ cond

pthread_cond_t impl::cond

## ◆ conf

struct pw_properties * impl::conf

Referenced by sm_alsa_monitor_start(), sm_bluez5_monitor_start(), and sm_v4l2_monitor_start().

## ◆ conn

struct spa_dbus_connection* impl::conn

Referenced by pipewire__module_init().

## ◆ context

struct pw_context * impl::context

Referenced by pipewire__module_init(), pw_context_destroy(), pw_context_recalc_graph(), pw_filter_new(), pw_settings_clean(), pw_settings_init(), pw_stream_flush(), pw_stream_new(), pw_stream_trigger_process(), sm_bluez5_autoswitch_start(), sm_default_nodes_start(), sm_default_routes_start(), sm_libcamera_monitor_start(), sm_logind_start(), sm_policy_ep_start(), sm_policy_node_start(), sm_restore_stream_start(), sm_session_manager_start(), sm_suspend_node_start(), and sm_v4l2_monitor_start().

## ◆ context_listener

struct spa_hook impl::context_listener

Referenced by pipewire__module_init(), and pw_impl_client_destroy().

## ◆ core

struct pw_core * impl::core

## ◆ core_listener

struct spa_hook impl::core_listener

## ◆ core_proxy_listener

struct spa_hook impl::core_proxy_listener

## ◆ count

int64_t impl::count

## ◆ data

uint8_t impl::data[MAX_BUFFER]

## ◆ dbus

struct spa_dbus* impl::dbus

## ◆ dbus_connection_listener

struct spa_hook impl::dbus_connection_listener

## ◆ def

struct metadata impl::def

Referenced by pw_impl_metadata_set_implementation().

## ◆ default_sink

char* impl::default_sink

## ◆ defaults

struct default_node impl::defaults[4]

Referenced by sm_policy_node_start().

## ◆ device_list

struct spa_list impl::device_list

Referenced by sm_bluez5_monitor_start(), sm_libcamera_monitor_start(), and sm_v4l2_monitor_start().

## ◆ do_disconnect

unsigned int impl::do_disconnect

## ◆ empty [1/2]

uint32_t impl::empty

## ◆ empty [2/2]

uint8_t impl::empty[8192]

## ◆ endpoint_link_list

struct spa_list impl::endpoint_link_list

## ◆ endpoint_links

struct pw_map impl::endpoint_links

list of struct endpoint_link

## ◆ endpoint_list

struct spa_list impl::endpoint_list

Referenced by sm_policy_ep_start().

## ◆ flush

uint8_t impl::flush[MAX_BUFFER+sizeof(struct spa_pod_struct)]

## ◆ flush_timeout

struct spa_source* impl::flush_timeout

## ◆ flushing

unsigned int impl::flushing

## ◆ frame_size

uint32_t impl::frame_size

## ◆ global

struct pw_global* impl::global

Referenced by pipewire__module_init().

## ◆ globals

struct pw_map impl::globals

## ◆ graph

struct graph impl::graph

Referenced by pipewire__module_init().

## ◆ handle

struct spa_handle * impl::handle

Referenced by sm_libcamera_monitor_start(), and sm_v4l2_monitor_start().

## ◆ have_info

bool impl::have_info

## ◆ hooks

struct spa_hook_list impl::hooks

Referenced by pw_filter_remove_port(), and sm_media_session_add_listener().

## ◆ id

uint32_t impl::id

Referenced by pipewire__module_init().

## ◆ idle_timeout

struct spa_source * impl::idle_timeout

## ◆ info

struct spa_audio_info_raw impl::info

Referenced by pw_impl_link_activate().

## ◆ jack_device

struct pw_proxy* impl::jack_device

## ◆ jack_timeout

struct spa_source* impl::jack_timeout

## ◆ last_seq

int impl::last_seq

Referenced by sm_media_session_schedule_rescan(), and sm_media_session_sync().

## ◆ link_list

struct spa_list impl::link_list

map of endpoint_link

## ◆ linking_node_removed

unsigned int impl::linking_node_removed

## ◆ listener

struct spa_hook impl::listener

Referenced by pw_impl_client_add_listener(), pw_impl_link_add_listener(), sm_access_flatpak_start(), sm_alsa_midi_start(), sm_bluez5_autoswitch_start(), sm_bluez5_endpoint_start(), sm_default_nodes_start(), sm_default_routes_start(), sm_libcamera_monitor_start(), sm_policy_ep_start(), sm_session_manager_start(), sm_stream_endpoint_start(), sm_suspend_node_start(), sm_v4l2_endpoint_start(), and sm_v4l2_monitor_start().

## ◆ listening

unsigned int impl::listening

## ◆ lock

pthread_mutex_t impl::lock

## ◆ loop [1/2]

struct pw_main_loop* impl::loop

## ◆ loop [2/2]

struct pw_loop* impl::loop

Referenced by pipewire__module_init(), and pw_loop_destroy().

## ◆ mem

struct pw_memblock* impl::mem

Referenced by pw_control_add_link(), and pw_control_destroy().

## ◆ meta_listener

struct spa_hook impl::meta_listener

## ◆ metadata [1/2]

struct pw_metadata* impl::metadata

## ◆ metadata [2/2]

struct pw_impl_metadata* impl::metadata

Referenced by pw_settings_clean(), pw_settings_init(), and sm_restore_stream_start().

## ◆ metadata_listener

struct spa_hook impl::metadata_listener

Referenced by sm_restore_stream_start().

## ◆ mode

uint32_t impl::mode

Referenced by pipewire__module_init().

## ◆ module

struct pw_impl_module * impl::module

Referenced by pipewire__module_init(), and pw_impl_module_destroy().

## ◆ module_listener

struct spa_hook impl::module_listener

Referenced by pipewire__module_init().

## ◆ modules

struct pw_properties* impl::modules

## ◆ monitor [1/2]

struct spa_device * impl::monitor

Referenced by sm_libcamera_monitor_start(), sm_logind_start(), and sm_v4l2_monitor_start().

## ◆ monitor [2/2]

sd_login_monitor* impl::monitor

## ◆ monitor_core

struct pw_core* impl::monitor_core

Referenced by sm_media_session_export(), sm_media_session_export_device(), and sm_media_session_export_node().

## ◆ monitor_listener

struct spa_hook impl::monitor_listener

## ◆ monitor_registry

struct pw_registry* impl::monitor_registry

## ◆ monitor_registry_listener

struct spa_hook impl::monitor_registry_listener

## ◆ monitor_seq

int impl::monitor_seq

## ◆ nice_level

int impl::nice_level

## ◆ node_list

struct spa_list impl::node_list

Referenced by sm_suspend_node_start().

## ◆ node_list_changed

unsigned int impl::node_list_changed

## ◆ notify

struct spa_source* impl::notify

## ◆ now

struct timespec impl::now

## ◆ object_list

struct spa_list impl::object_list

all sm_objects

Referenced by sm_media_session_add_listener(), and sm_media_session_for_each_object().

## ◆ out_buffer

void* impl::out_buffer[SPA_AUDIO_MAX_CHANNELS]

## ◆ out_ring

struct spa_ringbuffer impl::out_ring

## ◆ out_ringsize

uint32_t impl::out_ringsize

## ◆ pa_context

pa_context* impl::pa_context

## ◆ pa_mainloop

pa_threaded_mainloop* impl::pa_mainloop

## ◆ pa_stream

pa_stream* impl::pa_stream

## ◆ param_list

struct spa_list impl::param_list

Referenced by pw_context_create_device(), pw_context_create_node(), and pw_context_create_port().

## ◆ pending_list

struct spa_list impl::pending_list

Referenced by pw_context_create_device(), pw_context_create_node(), and pw_context_create_port().

## ◆ play_buffer

void* impl::play_buffer[SPA_AUDIO_MAX_CHANNELS]

## ◆ play_rate_match

struct spa_io_rate_match* impl::play_rate_match

## ◆ play_ring

struct spa_ringbuffer impl::play_ring

## ◆ play_ringsize

uint32_t impl::play_ringsize

## ◆ playback [1/2]

struct pw_stream * impl::playback

## ◆ playback [2/2]

bool impl::playback

## ◆ playback_info

struct spa_audio_info_raw impl::playback_info

## ◆ playback_listener

struct spa_hook impl::playback_listener

## ◆ playback_props

struct pw_properties * impl::playback_props

Referenced by pipewire__module_init().

## ◆ plugin_list

struct spa_list impl::plugin_list

Referenced by pipewire__module_init().

## ◆ policy_core

struct pw_core* impl::policy_core

Referenced by sm_media_session_roundtrip(), sm_media_session_schedule_rescan(), and sm_media_session_sync().

## ◆ policy_listener

struct spa_hook impl::policy_listener

## ◆ portal_pid

pid_t impl::portal_pid

## ◆ portal_pid_pending

DBusPendingCall* impl::portal_pid_pending

## ◆ properties

struct pw_properties * impl::properties

Referenced by get_pending_save(), get_saved_headset_profile(), get_saved_profile(), pipewire__module_init(), set_pending_save(), set_saved_headset_profile(), set_saved_profile(), sm_bluez5_autoswitch_start(), and sm_default_nodes_start().

## ◆ props

struct pw_properties * impl::props

Referenced by pipewire__module_init(), sm_alsa_midi_start(), sm_alsa_monitor_start(), sm_bluez5_monitor_start(), and sm_restore_stream_start().

## ◆ proxy

struct pw_proxy* impl::proxy

## ◆ proxy_client_session_listener

struct spa_hook impl::proxy_client_session_listener

## ◆ proxy_policy_listener

struct spa_hook impl::proxy_policy_listener

## ◆ pulse

struct pw_protocol_pulse* impl::pulse

Referenced by pipewire__module_init().

## ◆ rate

uint32_t impl::rate

Referenced by pipewire__module_init().

## ◆ rate_match

struct spa_io_rate_match * impl::rate_match

## ◆ rec_buffer

void* impl::rec_buffer[SPA_AUDIO_MAX_CHANNELS]

## ◆ rec_rate_match

struct spa_io_rate_match* impl::rec_rate_match

## ◆ rec_ring

struct spa_ringbuffer impl::rec_ring

## ◆ rec_ringsize

uint32_t impl::rec_ringsize

## ◆ record_count

unsigned int impl::record_count

## ◆ registry

struct pw_registry* impl::registry

Referenced by sm_media_session_destroy_object().

## ◆ registry_event_list

struct spa_list impl::registry_event_list

pending registry events

## ◆ registry_listener

struct spa_hook impl::registry_listener

## ◆ rescan_pending

unsigned int impl::rescan_pending

Referenced by sm_media_session_schedule_rescan().

## ◆ rescan_seq

int impl::rescan_seq

list of struct sync

Referenced by sm_media_session_schedule_rescan().

## ◆ reserve

unsigned int impl::reserve

## ◆ restore_timeout

struct spa_source* impl::restore_timeout

## ◆ ring

struct spa_ringbuffer impl::ring

Referenced by pipewire__module_init().

## ◆ rt_prio

int impl::rt_prio

## ◆ rt_time_hard

rlim_t impl::rt_time_hard

## ◆ rt_time_soft

rlim_t impl::rt_time_soft

## ◆ sample_rate

uint32_t impl::sample_rate

Referenced by sm_policy_node_start().

## ◆ scanning

unsigned int impl::scanning

Referenced by sm_media_session_schedule_rescan().

## ◆ seat_active [1/2]

bool impl::seat_active

Referenced by sm_bluez5_monitor_start(), and sm_media_session_seat_active_changed().

## ◆ seat_active [2/2]

unsigned int impl::seat_active

## ◆ seq

int impl::seq

Referenced by pw_filter_get_time(), and pw_stream_get_time().

## ◆ server_list

struct spa_list impl::server_list

Referenced by pipewire__module_init().

## ◆ session

struct sm_media_session * impl::session

Referenced by sm_access_flatpak_start(), sm_access_portal_start(), sm_alsa_midi_start(), sm_alsa_monitor_start(), sm_bluez5_autoswitch_start(), sm_bluez5_endpoint_start(), sm_bluez5_monitor_start(), sm_default_nodes_start(), sm_default_routes_start(), sm_libcamera_monitor_start(), sm_logind_start(), sm_policy_ep_start(), sm_policy_node_start(), sm_restore_stream_start(), sm_session_manager_start(), sm_stream_endpoint_start(), sm_suspend_node_start(), sm_v4l2_endpoint_start(), and sm_v4l2_monitor_start().

## ◆ session_listener

struct spa_hook impl::session_listener

Referenced by sm_bluez5_monitor_start().

## ◆ sink

struct pw_stream* impl::sink

## ◆ sink_browser

AvahiServiceBrowser* impl::sink_browser

## ◆ sink_listener

struct spa_hook impl::sink_listener

## ◆ sink_props

struct pw_properties* impl::sink_props

Referenced by pipewire__module_init().

## ◆ sink_ready

unsigned int impl::sink_ready

## ◆ source [1/2]

struct spa_source impl::source

## ◆ source [2/2]

struct pw_stream* impl::source

Referenced by sm_logind_start().

## ◆ source_browser

AvahiServiceBrowser* impl::source_browser

## ◆ source_listener

struct spa_hook impl::source_listener

## ◆ source_props

struct pw_properties* impl::source_props

Referenced by pipewire__module_init().

## ◆ stream

struct pw_stream * impl::stream

## ◆ stream_listener

struct spa_hook impl::stream_listener

## ◆ stream_props

struct pw_properties * impl::stream_props

Referenced by pipewire__module_init().

## ◆ streams_follow_default

bool impl::streams_follow_default

Referenced by sm_policy_node_start().

## ◆ switched

bool impl::switched

## ◆ sync

unsigned int impl::sync

## ◆ sync_list

struct spa_list impl::sync_list

list of struct link

Referenced by sm_media_session_sync().

## ◆ system_bus

struct pw_rtkit_bus* impl::system_bus

## ◆ this [1/4]

struct sm_media_session impl::this

## ◆ this [2/4]

struct pw_control impl::this

Referenced by pw_context_create_client(), pw_context_create_device(), pw_context_create_metadata(), pw_context_create_node(), pw_context_create_port(), pw_context_new(), pw_control_new(), pw_global_new(), pw_impl_link_activate(), pw_loop_new(), pw_mempool_new(), pw_properties_update_string(), pw_proxy_new(), pw_resource_new(), and sm_media_session_roundtrip().

## ◆ this [3/4]

struct pw_impl_device impl::this

## ◆ this [4/4]

struct pw_impl_metadata impl::this

## ◆ thread_utils

struct spa_thread_utils impl::thread_utils

## ◆ threads_list

struct spa_list impl::threads_list

## ◆ tmp

uint8_t impl::tmp[TMP_BUFFER]

## ◆ to_restore

struct pw_properties* impl::to_restore

Referenced by sm_default_routes_start().

## ◆ tunnel_list

struct spa_list impl::tunnel_list

Referenced by pipewire__module_init().

## ◆ unloading

unsigned int impl::unloading

## ◆ work

struct pw_work_queue * impl::work

Referenced by pipewire__module_init(), and pw_impl_link_prepare().

## ◆ work_queue

struct pw_work_queue* impl::work_queue

The documentation for this struct was generated from the following files:

- control.c
- impl-device.c
- impl-metadata.c
- settings.c
- module-access.c
- module-echo-cancel.c
- module-example-sink.c
- module-example-source.c
- module-filter-chain.c
- module-loopback.c
- module-portal.c
- module-profiler.c
- module-protocol-pulse.c
- module-protocol-simple.c
- module-pulse-tunnel.c
- module-rt.c
- module-rtkit.c
- module-zeroconf-discover.c
- access-flatpak.c
- access-portal.c
- alsa-midi.c
- alsa-monitor.c
- alsa-endpoint.c
- bluez-monitor.c
- bluez-endpoint.c
- bluez-autoswitch.c
- default-nodes.c
- default-profile.c
- default-routes.c
- media-session.c
- session-manager.c
- stream-endpoint.c
- restore-stream.c
- policy-ep.c
- policy-node.c
- v4l2-monitor.c
- v4l2-endpoint.c
- libcamera-monitor.c
- suspend-node.c
- logind.c